Re: [PATCH v2 2/2] perf test: Add DWARF callchain conversion test
From: Ian Rogers
Date: Mon Jan 12 2026 - 18:16:12 EST
On Fri, Jan 9, 2026 at 5:17 PM Namhyung Kim <namhyung@xxxxxxxxxx> wrote:
>
> $ ./perf test -vv "DWARF callchain"
> 87: perf inject to convert DWARF callchains to regular ones:
> --- start ---
> test child forked, pid 1560328
> recording data with DWARF callchain
> [ perf record: Woken up 4 times to write data ]
> [ perf record: Captured and wrote 0.908 MB /tmp/perf-test.nM3WoW (105 samples) ]
> convert DWARF callchain using perf inject
> compare the both result excluding inlined functions
> ---- end(0) ----
> 87: perf inject to convert DWARF callchains to regular ones : Ok
>
> Signed-off-by: Namhyung Kim <namhyung@xxxxxxxxxx>
Reviewed-by: Ian Rogers <irogers@xxxxxxxxxx>
Thanks,
Ian
> ---
> tools/perf/tests/shell/inject-callchain.sh | 45 ++++++++++++++++++++++
> 1 file changed, 45 insertions(+)
> create mode 100755 tools/perf/tests/shell/inject-callchain.sh
>
> diff --git a/tools/perf/tests/shell/inject-callchain.sh b/tools/perf/tests/shell/inject-callchain.sh
> new file mode 100755
> index 0000000000000000..a1cba8010f954d21
> --- /dev/null
> +++ b/tools/perf/tests/shell/inject-callchain.sh
> @@ -0,0 +1,45 @@
> +#!/bin/bash
> +# perf inject to convert DWARF callchains to regular ones
> +# SPDX-License-Identifier: GPL-2.0
> +
> +if ! perf check feature -q dwarf; then
> + echo "SKIP: DWARF support is not available"
> + exit 2
> +fi
> +
> +TESTDATA=$(mktemp /tmp/perf-test.XXXXXX)
> +
> +err=0
> +
> +cleanup()
> +{
> + trap - EXIT TERM INT
> + rm -f ${TESTDATA}*
> +}
> +
> +trap_cleanup()
> +{
> + cleanup
> + exit 1
> +}
> +
> +trap trap_cleanup EXIT TERM INT
> +
> +echo "recording data with DWARF callchain"
> +perf record -F 999 --call-graph dwarf -o "${TESTDATA}" -- perf test -w noploop
> +
> +echo "convert DWARF callchain using perf inject"
> +perf inject -i "${TESTDATA}" --convert-callchain -o "${TESTDATA}.new"
> +
> +perf report -i "${TESTDATA}" --no-children -q --percent-limit=1 > ${TESTDATA}.out
> +perf report -i "${TESTDATA}.new" --no-children -q --percent-limit=1 > ${TESTDATA}.new.out
> +
> +echo "compare the both result excluding inlined functions"
> +if diff -u "${TESTDATA}.out" "${TESTDATA}.new.out" | grep "^- " | grep -qv "(inlined)"; then
> + echo "Found some differences"
> + diff -u "${TESTDATA}.out" "${TESTDATA}.new.out"
> + err=1
> +fi
> +
> +cleanup
> +exit $err
> --
> 2.52.0.457.g6b5491de43-goog
>